<?php
/** ---------------------------------------------------------
 *   スコープ、参照渡しとユーザ関数の関連:利用比較の例
 *  2015.08.18 作成 yoshi of CXMedia Inc.
 * ---------------------------------------------------------- */
header("Content-type:text/plain; charset=UTF-8");

// グローバル変数
$strGlobal = "■野菜の価格";
$product   = "トマト";
$intPrice1 = '';
$intPrice2 = '';

// 「global」の宣言→割引後の価格表示
string_edit(500);
// ユーザ関数で設定した値の表示
echo "ユーザ関数で設定価格1：",$intPrice1,"\n";

// 「参照渡し」の利用→割引後の価格表示
string_edit_ref($strGlobal,500,$intPrice2,$product);
// ユーザ関数の参照渡しで設定した値の表示
echo "ユーザ関数で設定価格2：",$intPrice2,"\n";

/** -------------------------------------------------
 *   ユーザ定義関数：「global」の宣言と宣言なしの比較
 *   @引数：定価
 * -------------------------------------------------- */
function string_edit($num){
    // メイン処理で宣言したグローバル変数をユーザ関数内で宣言
    global $strGlobal,$intPrice1;
    
    // 割引率:20%の計算：グローバル変数 $intPriceに設定
    $intPrice1 = (int) $num * (1 - 0.2);  //(int)は、整数のキャスト処理
    // グローバル変数の利用
    echo $strGlobal ."\n";
    // $productは、グローバル宣言していないのでローカル変数、「null」表示になる
    echo $product ."は" .$intPrice1 ."円です\n";
}

/** ----------------------------------------------------------
 *   ユーザ定義関数：「global」なしで、参照渡しの利用
 *   @引数：商品分野、定価、割引価格（参照渡しで設定）、商品名
 * ----------------------------------------------------------- */
function string_edit_ref($str, $num, &$price,$vegitable){
    // 割引率:20%の計算：$priceに代入した価格は、参照渡しの$intPriceに設定される
    $price = (int) $num * (1 - 0.2);  //(int)は、整数のキャスト処理
    // 引数の$str ローカル変数の利用
    echo $str ."\n";
    // $vegitableは、引数のローカル変数の利用
    echo $vegitable ."は" .$price ."円です\n";
}
?>
